/* StegFS - The Steganographic File System */
/* Copyright (c)1999 Andrew McDonald <andrew@mcdonald.org.uk> */

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/sysmacros.h>

int main(int argc, char *args[]) {

  struct stat statf;
  char * pass;
  FILE * procstegfs;
  char * buf;

  if (argc != 3) {
    printf("usage:\n");
    printf("stegfsopen /mnt/mntpoint levelnum\n");
    exit(1);
  }

  stat (args[1], &statf);

  printf("opening filesystem on %02x:%02x at level %u\n",
	 (unsigned) major(statf.st_dev),
	 (unsigned) minor(statf.st_dev), atoi(args[2]));

  procstegfs = fopen("/proc/stegfs", "r+");

  if(!procstegfs) {
    printf("Error: stegfs module not loaded\n");
    exit(1);
  }

  pass = getpass("Enter passphrase: ");

  buf = malloc(strlen(pass)+25);
  sprintf(buf, "%02u:%02u %d %s", (unsigned) major(statf.st_dev),
	 (unsigned) minor(statf.st_dev), atoi(args[2]), pass);

  printf("Sending: *%s*\n", buf);
  fprintf(procstegfs, "%02x:%02x %d %s", (unsigned) major(statf.st_dev),
	 (unsigned) minor(statf.st_dev), atoi(args[2]), pass);
  fclose(procstegfs);

  return 0;
}
